; ==================================================================================================
; Title:   AutobufferApp.asm
; Author:  G. Friedrich  @ March 2011
; Version: 1.0.0
; Purpose: Autobuffer test code.
; ==================================================================================================


%include @Environ(OA32_PATH)\\Code\\Macros\\Model.inc  ;Include & initialize standard modules
SysSetup OOP_WINDOWS, DEBUG(WND)

IncludeAPIs comdlg32

TEST_PAGES  equ  10240                              ;40 MB

MakeObjects Autobuffer                              ;Include Shape, Triangle- and RectangleShape

.code                                               ;Begin Code segment

start:                                              ;Program entry point
    SysInit                                         ;Runtime initialization of the OOP model

    invoke SetExceptionMessageA, $OfsCStr("This is the final exception handler"), \
                                 $OfsCStr("Final Exception Handler"), \
                                 NULL

    mov ebx, $New(Autobuffer)
    OCall ebx::Autobuffer.Init, NULL, 1, TEST_PAGES

    mov edi, $New(Autobuffer)
    OCall edi::Autobuffer.Init, NULL, 1, TEST_PAGES

;   Stack EXCEPTION_GUARD_PAGE test
    DbgText "Start of stack test"
    mov dword ptr [esp - 1*4096], 0
    mov dword ptr [esp - 2*4096], 0
    mov dword ptr [esp - 3*4096], 0
    mov dword ptr [esp - 4*4096], 0
    mov dword ptr [esp - 5*4096], 0
    mov dword ptr [esp - 6*4096], 0
    mov dword ptr [esp - 7*4096], 0
    mov dword ptr [esp - 8*4096], 0
    DbgText "End of stack test\n"

    mov eax, [ebx].Autobuffer.pBuffer
;   Test on buffer #1
    DbgText "Start testing Autobuffer #1"
    mov dword ptr [eax + 0*4096], 100
    mov dword ptr [eax + 1*4096], 100
    mov dword ptr [eax + 2*4096], 100
    mov dword ptr [eax + 3*4096], 100

    MemAlloc TEST_PAGES*4096
    invoke MemClone, [ebx].Autobuffer.pBuffer, eax, TEST_PAGES*4096
    DbgText "End of testing Autobuffer #1\n"



    mov eax, [edi].Autobuffer.pBuffer
    DbgText "Start of testing Autobuffer #2"
    mov dword ptr [eax + 0*4096], 100
    mov dword ptr [eax + 1*4096], 100
    mov dword ptr [eax + 2*4096], 100
    mov dword ptr [eax + 3*4096], 100

    MemAlloc TEST_PAGES*4096
    invoke MemClone, [ebx].Autobuffer.pBuffer, eax, TEST_PAGES*4096
    DbgText "End of testing Autobuffer #2\n"

;;   Test #3 => should trigger an EXCEPTION_GUARD_PAGE (80000001h) exception.
;    DbgText "Start of test #3\n"
;    mov eax, [ebx].Autobuffer.pBuffer
;    mov dword ptr [eax + TEST_PAGES*4096], 100
;    DbgText "End of test #3\n"
;
;    xor eax, eax
;    div eax

    Kill ebx
    Kill edi

    DbgText "Tests succeeded\:"

    SysDone                                         ;Runtime finalization of the OOP model

    invoke ExitProcess, 0
end start
